// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DBTrackTool.pas' rev: 22.00

#ifndef DbtracktoolHPP
#define DbtracktoolHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Variants.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TTrackingEvent { teAppend, teEdit, teDelete, teOpen, teClose, teView };
#pragma option pop

typedef Set<TTrackingEvent, TTrackingEvent::teAppend, TTrackingEvent::teView>  TTrackingEvents;

#pragma option push -b-
enum TTrackingOption { toTrackNoChanges, toUseFieldName };
#pragma option pop

typedef Set<TTrackingOption, TTrackingOption::toTrackNoChanges, TTrackingOption::toUseFieldName>  TTrackingOptions;

class DELPHICLASS TTrackRecTarget;
typedef void __fastcall (__closure *TTrackGetDateTime)(TTrackRecTarget* Sender, TDateTime &DateTime);

class DELPHICLASS TTrackRecSource;
typedef void __fastcall (__closure *TTrackEditMessage)(TTrackRecSource* Sender, UnicodeString &Msg);

#pragma option push -b-
enum TChangesFormat { frmText, frmMemoGrid };
#pragma option pop

class PASCALIMPLEMENTATION TTrackRecTarget : public TComponent
{
	typedef TComponent inherited;
	
private:
	bool FDisable;
	TDataSet* FTargetDataSet;
	UnicodeString FFieldDateTime;
	UnicodeString FFieldUser;
	UnicodeString FFieldAction;
	UnicodeString FFieldTableName;
	UnicodeString FFieldKeyValue;
	UnicodeString FFieldChanges;
	UnicodeString FFieldMemo;
	UnicodeString FFieldCustomMemo;
	UnicodeString FFieldSpecial;
	UnicodeString FActiveUser;
	TTrackGetDateTime FOnGetDateTime;
	TChangesFormat FChangesFormat;
	
protected:
	virtual void __fastcall Loaded(void);
	void __fastcall SetTargetDataSet(TDataSet* Value);
	virtual void __fastcall Notification(TComponent* AComponent, TOperation Operation);
	
public:
	__fastcall virtual TTrackRecTarget(TComponent* AOwner);
	__fastcall virtual ~TTrackRecTarget(void);
	void __fastcall SaveTrackRec(TTrackingEvent Action, UnicodeString TableName, UnicodeString KeyValue, UnicodeString Changes, UnicodeString Memo, int Special, UnicodeString CustomMemo = L"");
	
__published:
	__property TDataSet* TargetDataSet = {read=FTargetDataSet, write=SetTargetDataSet};
	__property bool Disable = {read=FDisable, write=FDisable, nodefault};
	__property UnicodeString FieldDateTime = {read=FFieldDateTime, write=FFieldDateTime};
	__property UnicodeString FieldUser = {read=FFieldUser, write=FFieldUser};
	__property UnicodeString FieldAction = {read=FFieldAction, write=FFieldAction};
	__property UnicodeString FieldTableName = {read=FFieldTableName, write=FFieldTableName};
	__property UnicodeString FieldKeyValue = {read=FFieldKeyValue, write=FFieldKeyValue};
	__property UnicodeString FieldChanges = {read=FFieldChanges, write=FFieldChanges};
	__property UnicodeString FieldMemo = {read=FFieldMemo, write=FFieldMemo};
	__property UnicodeString FieldCustomMemo = {read=FFieldCustomMemo, write=FFieldCustomMemo};
	__property UnicodeString FieldSpecial = {read=FFieldSpecial, write=FFieldSpecial};
	__property UnicodeString ActiveUser = {read=FActiveUser, write=FActiveUser};
	__property TTrackGetDateTime OnGetDateTime = {read=FOnGetDateTime, write=FOnGetDateTime};
	__property TChangesFormat ChangesFormat = {read=FChangesFormat, write=FChangesFormat, nodefault};
};


class PASCALIMPLEMENTATION TTrackRecSource : public TComponent
{
	typedef TComponent inherited;
	
private:
	typedef System::DynamicArray<Variant> _TTrackRecSource__1;
	
	typedef System::DynamicArray<Variant> _TTrackRecSource__2;
	
	
private:
	bool FDisable;
	TDataSet* FTrackedDataSet;
	TTrackRecTarget* FTrackRecTarget;
	TTrackingEvents FTrackingEvents;
	TTrackingOptions FTrackingOptions;
	TStrings* FTrackedFields;
	TStrings* FTrackedSpecialFields;
	UnicodeString FKeyFields;
	UnicodeString FTableName;
	UnicodeString FChangesFormatStr;
	UnicodeString FTableOpenStr;
	UnicodeString FTableCloseStr;
	_TTrackRecSource__1 OldRecValues;
	_TTrackRecSource__2 OldRecSpecialValues;
	UnicodeString FKeyValues;
	TTrackingEvent FLastAction;
	UnicodeString FLastMsg;
	UnicodeString FLastMsgSpec;
	TTrackEditMessage FOnEditMessage;
	TTrackEditMessage FOnGetMemo;
	TTrackEditMessage FOnGetCustomMemo;
	TDataSetNotifyEvent oldAfterEdit;
	TDataSetNotifyEvent oldAfterInsert;
	TDataSetNotifyEvent oldBeforePost;
	TDataSetNotifyEvent oldAfterPost;
	TDataSetNotifyEvent oldBeforeDelete;
	TDataSetNotifyEvent oldAfterDelete;
	TDataSetNotifyEvent oldAfterOpen;
	TDataSetNotifyEvent oldBeforeClose;
	void __fastcall AfterEdit(TDataSet* DataSet);
	void __fastcall AfterInsert(TDataSet* DataSet);
	void __fastcall BeforePost(TDataSet* DataSet);
	void __fastcall AfterPost(TDataSet* DataSet);
	void __fastcall BeforeDelete(TDataSet* DataSet);
	void __fastcall AfterDelete(TDataSet* DataSet);
	void __fastcall AfterOpen(TDataSet* DataSet);
	void __fastcall BeforeClose(TDataSet* DataSet);
	void __fastcall LinkDataSet(TDataSet* DS);
	void __fastcall UnLinkDataSet(TDataSet* DS);
	
protected:
	virtual void __fastcall Loaded(void);
	void __fastcall SetTrackedDataSet(TDataSet* Value);
	void __fastcall SetTrackRecTarget(TTrackRecTarget* Value);
	void __fastcall SetTrackedFields(TStrings* Value);
	void __fastcall SetTrackedSpecialFields(TStrings* Value);
	virtual void __fastcall Notification(TComponent* AComponent, TOperation Operation);
	void __fastcall FieldsChanged(TObject* Sender);
	void __fastcall CompareAndStoreChangeMsg(void);
	void __fastcall SaveTrackRecord(void);
	
public:
	__fastcall virtual TTrackRecSource(TComponent* AOwner);
	__fastcall virtual ~TTrackRecSource(void);
	void __fastcall LoadValues(void);
	void __fastcall LoadKeyValues(void);
	void __fastcall SaveChanges(void);
	void __fastcall SaveViewLog(bool ForceSaving = false);
	__property TTrackingEvent LastAction = {read=FLastAction, nodefault};
	__property UnicodeString LastMsg = {read=FLastMsg};
	__property UnicodeString LastMsgSpec = {read=FLastMsgSpec};
	__property UnicodeString KeyValues = {read=FKeyValues, write=FKeyValues};
	
__published:
	__property TDataSet* TrackedDataSet = {read=FTrackedDataSet, write=SetTrackedDataSet};
	__property bool Disable = {read=FDisable, write=FDisable, nodefault};
	__property TTrackRecTarget* TrackRecTarget = {read=FTrackRecTarget, write=SetTrackRecTarget};
	__property TTrackingEvents TrackingEvents = {read=FTrackingEvents, write=FTrackingEvents, nodefault};
	__property TTrackingOptions TrackingOptions = {read=FTrackingOptions, write=FTrackingOptions, nodefault};
	__property TStrings* TrackedFields = {read=FTrackedFields, write=SetTrackedFields};
	__property TStrings* TrackedSpecialFields = {read=FTrackedSpecialFields, write=SetTrackedSpecialFields};
	__property UnicodeString KeyFields = {read=FKeyFields, write=FKeyFields};
	__property UnicodeString TableName = {read=FTableName, write=FTableName};
	__property UnicodeString ChangesFormatStr = {read=FChangesFormatStr, write=FChangesFormatStr};
	__property UnicodeString TableOpenStr = {read=FTableOpenStr, write=FTableOpenStr};
	__property UnicodeString TableCloseStr = {read=FTableCloseStr, write=FTableCloseStr};
	__property TTrackEditMessage OnEditMessage = {read=FOnEditMessage, write=FOnEditMessage};
	__property TTrackEditMessage OnGetMemo = {read=FOnGetMemo, write=FOnGetMemo};
	__property TTrackEditMessage OnGetCustomMemo = {read=FOnGetCustomMemo, write=FOnGetCustomMemo};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DbtracktoolHPP
